:
# RCSid:
#	$Id: fqdn.sh,v 1.2 2001/08/30 08:07:30 sjg Exp $
#
#	@(#) Copyright (c) 1996 Simon J. Gerraty
#
#	This file is provided in the hope that it will
#	be of use.  There is absolutely NO WARRANTY.
#	Permission to copy, redistribute or otherwise
#	use this file is hereby granted provided that 
#	the above copyright notice and this notice are
#	left intact. 
#      
#	Please send copies of changes and bug-fixes to:
#	sjg@crufty.net
#

ETC_HOSTS=${ETC_HOSTS:-$DESTDIR/etc/hosts}

fqdn_hosts() {
        case "$1" in
	*.*) echo x $1;;
	"") ;;
	*.)
                egrep -i "^[1-9].*[ 	]$1" $ETC_HOSTS
                ;;
	*)
	        egrep -i "^[1-9].*[ 	]($1|$1[ 	].*)\$" $ETC_HOSTS
                ;;
	esac | while read addr canonical aliases
	do
                case "$canonical" in
		"") ;;
		*.*)
                        echo $canonical; break;;
		*)	for name in $aliases
			do
                                case "$name" in
				*.*) echo $name; return;;
				esac
                        done
                        ;;
                esac
        done
}

fqdn_dns() {
        if [ -s /etc/resolv.conf ]; then
                nslookup $1 2>&1 | grep Name: | cut -d: -f2
	fi
}

fqdn_fail() {
        echo $1
}

fqdn() {
        name=$1; shift
        dn=$name
        by=${*:-'hosts dns'}
        for m in $by fail
	do
                case "$dn" in
		*.*) echo $dn; break;;
		esac
                dn=`fqdn_$m $name`
	done
}


case ./$0 in
*/fqdn_host*) fqdn_hosts "$@";;
*/fqdn_dns*) fqdn_dns "$@";;
*/fqdn*) fqdn "$@";;
esac

        
